#include "Fahrzeug.h"
#include <math.h>

#include <iostream>
#include <iomanip>
using namespace std;

#define EPSILON 0.0166 //ca. 1 Minute wenn die Zeit in Stunden gemessen wird.

//globale Zeit bekanntmachen
extern double dGlobaleZeit;

//######################## Konstruktoren, Initialisierung, Destruktor ##################
void Fahrzeug::vInitialisierung(void) //Grundlegende Initialisierung der Membervariablen
{
	p_sName = "";
	p_dMaxGeschwindigkeit = 0.0;
	p_dZeit = 0.0;
	p_dGesamtStrecke = 0;

	// statischen Zhler inkrementieren und ID zuweisen
	p_iMaxID++;
	p_iID = p_iMaxID;
}

Fahrzeug::Fahrzeug(void) //Standard
{
	vInitialisierung();
//	cout << "Neues Fahrzeug ohne Namen mit ID " << p_iID << " erstellt." << endl;
}

Fahrzeug::Fahrzeug(string sIniName) //nur Name
{
	vInitialisierung();

	p_sName = sIniName; //Name aendern

/*	cout << "Neues Fahrzeug mit Namen " << p_sName << " und ID "
		<< p_iID << " erstellt." << endl;
*/
}

Fahrzeug::Fahrzeug(string sIniName, double dVMax) //Name und Hchstgeschwindigkeit
{
	vInitialisierung();

	p_sName = sIniName; //Name aendern
	p_dMaxGeschwindigkeit = dVMax; //Hoechstgeschwindigkeit festlegen

/*	cout << "Neues Fahrzeug mit Namen " << p_sName << ", ID " << p_iID
		<< " und VMax " << p_dMaxGeschwindigkeit << " km/h erstellt." << endl;
*/
}


Fahrzeug::~Fahrzeug(void) //Destruktor
{
/*	if(p_sName == "") 
		cout << "Fahrzeug ohne Namen mit ID " << p_iID << " geloescht." << endl;
	else
		cout << "Fahrzeug mit Namen " << p_sName << " geloescht." << endl;
*/
//Destroyy!
}

//############## Wirkfunktionen ###################################################

void Fahrzeug::vAusgabe(void) const //Ausgabefunktion
{
	cout << setw(4) << setiosflags(ios::left) << p_iID 
		<<  setw(10) << p_sName 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) 
		<< setw(10) << setprecision(2) << p_dMaxGeschwindigkeit 
		<< setw(10) << setprecision(2) << dGeschwindigkeit()
		<< setw(10) << setprecision(2) << setbase(10) << p_dGesamtStrecke 
		<< resetiosflags(ios::fixed) << resetiosflags(ios::right);
}


void Fahrzeug::vAbfertigung(void) //fertigt das Fahrzeug fuer einen Zeitschritt ab
{
	if(fabs(dGlobaleZeit - p_dZeit) > EPSILON)
	/*seit der letzten Abfertigung sind wenigstens EPSILON Stunden verstrichen.
	Diese Abfrage wird berflssig, wenn keine Instanzen der Klasse Fahrzeug mehr erstellt werden,
	da vor Aufruf der Funktion durch die abgeleiteten Klassen schon geprft wird.*/
	{
		p_dGesamtStrecke += (dGeschwindigkeit() * fabs(dGlobaleZeit - p_dZeit));
		p_dZeit = dGlobaleZeit;
	}
}


/*muss irgendwie beschrieben sein, aufgerufen wird letztenendes jedoch nur die Funktion,
welche in den abgeleiteten Klassen PKW und Fahrrad implementiert ist.*/
double Fahrzeug::dGeschwindigkeit(void) const {return 0.0;}
double Fahrzeug::dTanken(double dMenge){return 0.0;}
//(C) MG, WiSe 2011/2012