#pragma once

#include <string>
using namespace std;

class Fahrzeug
{
public:
	//Funktionen
	Fahrzeug(void);
	Fahrzeug(const Fahrzeug& farefUrbild); //selbst definierter Copy-Konstruktor
	Fahrzeug(string sIniName);
	Fahrzeug(string sIniName, double dVMax); //die drei Konstruktoren
	virtual ~Fahrzeug(void);

	virtual double dTanken(double dMenge = 0.0); //virtuelle Tankfunktion
	virtual void vAusgabe(void) const; //Ausgabefunktion
	virtual ostream& ostreamAusgabe(ostream& ostreamrefZiel) const; //Ausgabefunktion fuer den ueberladenen <<-Operator
	virtual void vAbfertigung(void); //Abfertigungsfunktion

	virtual double dGeschwindigkeit(void) const; //Die Geschwindigkeitsfunktion

	bool operator<(const Fahrzeug& farefAnderesFahrzeug); //Vergleichsoperator
	void operator=(const Fahrzeug& farefUrbild); //neuer Zuweisungsoperator

protected:
	//Funktionen
	void vInitialisierung(void);
	//Variablen
	string p_sName;					//Name des Fahrzeugs
	int p_iID;						//eideutige ID
	double p_dMaxGeschwindigkeit;	//technische Hoechstgeschwindigkeit des Fahrzeugs
	double p_dGesamtStrecke;		//Tachostand des Fahrzeugs
	double p_dZeit;					//Zeit, zu der das Fahrzeug zuletzt abgefertigt wurde
	//statische Variablen
	static int p_iMaxID;			//globales Maximum der vergebenen IDs	
};

ostream& operator<<(ostream& ostreamrefZiel, const Fahrzeug& fahrzeugrefObjekt);
//(C) MG, WiSe 2011/2012