#include "Fahrzeug.h"
#include "PKW.h"
#include "Fahrrad.h"
#include <vector>

#include <iostream>
#include <string>
#include <iomanip>
using namespace std;

#define TAKT 0.25 //Laenge eines Zeittaktes in Stunden

// globale Deklarationen
int Fahrzeug::p_iMaxID = 0;
double dGlobaleZeit = 0.0;

void vTabellenKopf() //gibt den formatierten Kopf einer Fahrzeugtabelle aus
{
	cout << setw(4) << setiosflags(ios::left) << "ID" 
		<<  setw(10) << "Name" 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setw(10) << "Vmax (km/h)"
		<< setw(10) << "V (km/h)"
		<< setw(10) << "ODT (km)" 
		<< setw(10) << "fuel (l)"
		<< setw(15) << "OConsumpt (l)" << endl << resetiosflags(ios::right)
		<< "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
}

void vAufgabe_1()
{
	string sEingabe = "";

	//erzeuge einige Fahrzeuge
	Fahrzeug faAuto1;
	Fahrzeug faAuto2("Auto 1");
	Fahrzeug faAuto3;
	Fahrzeug faAuto4("PKW 2");
	Fahrzeug faAuto8("Opel Corsa", 100.0);
	Fahrzeug faAuto9("BMW M5", 305.0);
	Fahrzeug faAuto10("Mofa", 25.8);

	//erzeuge interaktiv drei dynamische Fahrzeuge
	cout << "Geben Sie nacheinander 3 Namen fuer Fahrzeuge ein, zwischendurch ENTER druecken."
		<< endl;	
	cin >> sEingabe; Fahrzeug* ptAuto5 = new Fahrzeug(sEingabe);
	cin >> sEingabe; Fahrzeug* ptAuto6 = new Fahrzeug(sEingabe);
	cin >> sEingabe; Fahrzeug* ptAuto7 = new Fahrzeug(sEingabe);

	//gib alle bekannten Fahrzeuge aus:
	vTabellenKopf();
	faAuto1.vAusgabe(); cout << endl;
	faAuto2.vAusgabe(); cout << endl;
	faAuto3.vAusgabe(); cout << endl;
	faAuto4.vAusgabe(); cout << endl;
	ptAuto5->vAusgabe(); cout << endl;
	ptAuto6->vAusgabe(); cout << endl;
	ptAuto7->vAusgabe(); cout << endl;

	faAuto8.vAusgabe(); cout << endl;//faAuto8,9,10 haben VMax != 0...
	faAuto9.vAusgabe(); cout << endl;
	faAuto10.vAusgabe(); cout << endl;

	//5 Zeitschritte lang simulieren...
	cout << "Start der Simulation: " << endl << endl;
	for(int i=0; i <= 5; i++)
	{
		cout << i << ". Takt, nach " << (double)i * TAKT << " Stunden." << endl;
		// Abfertigen
		faAuto8.vAbfertigung();
		faAuto8.vAbfertigung(); //testen, ob die doppelte Abfertigung abgefangen wird
		faAuto9.vAbfertigung();
		faAuto10.vAbfertigung();
		// Ausgabe
		vTabellenKopf();
		faAuto8.vAusgabe(); cout << endl;
		faAuto9.vAusgabe(); cout << endl;
		faAuto10.vAusgabe(); cout << endl;
		cout << endl;

		dGlobaleZeit += TAKT;
	}
	
	//garbage collection
	delete ptAuto6;
	delete ptAuto7;
	delete ptAuto5;
}

void vAufgabe_1_deb()
{
	Fahrzeug* aAutoListe[4];
	for (int i = 0; i<=3; i++) //erzeuge 4 simple Fahrzeuge
	{
		aAutoListe[i] = new Fahrzeug("Testmobil", 50.0);
	}

	//HIER BAUEN WIR EINEN FEHLER EIN DEN WIR MIT DEM DEBUGGER FINDEN WOLLEN...
	//aAutoListe[2] = 0;

	vTabellenKopf();
	for (int i = 0; i<=3; i++) //gib die Fahrzeuge aus
	{
		aAutoListe[i]->vAusgabe(); cout << endl;
	}

	for (int i = 0; i<=3; i++) //garbage collection
	{
		delete aAutoListe[i];
	}
/*Wenn aAutoListe[2].vAusgabe() aufgerufen wird, dann schreit der Debugger weil auf eine
geschuetzte Speicherzelle (0x0000038) zugegriffen werden soll. Dies geschieht, weil der
Zeiger vorher umgesetzt wurde.
*/
}

void vAufgabe_2()
{
	//Vektor anlegen:
	vector<Fahrzeug*> vectFahrzeugliste;

	//Eingabe der Fahrzeuge
	string sEingabe = "", sNeuName = "";
	double dNeuVMax = 0, dNeuTankvol = 0, dNeuVerbrauch = 0;


	while(1) //Einlesen der Daten
	{
		cout << "Was soll erstellt werden?" << endl << "PKW (p), Fahrrad (f), Eingabe beenden (e)\t";
		cin >> sEingabe;

		if(sEingabe == "e") break;
		if(sEingabe == "p")
		{	//PKW
			cout << "Geben Sie den Namen des neuen PKW ein:\t";
			cin >> sNeuName;
			cout << "Geben Sie die max. Geschwindigkeit ein (km/h):\t";
			cin >> dNeuVMax;
			cout << "Geben Sie den Verbrauch ein (l/100km):\t";
			cin >> dNeuVerbrauch;
			cout << "Geben Sie das Tankvolumen ein (in Litern, '0' fuer default 55l):\t";
			cin >> dNeuTankvol;
			
			if(dNeuTankvol != 0) 
				vectFahrzeugliste.push_back(
				new PKW(sNeuName, dNeuVMax, dNeuVerbrauch, dNeuTankvol)
				);
			else 
				vectFahrzeugliste.push_back(
				new PKW(sNeuName, dNeuVMax, dNeuVerbrauch)
				);
		}
		else if(sEingabe == "f")
		{	//Fahrrad
			cout << "Geben Sie den Namen des neuen Fahrrades ein:\t";
			cin >> sNeuName;
			cout << "Geben Sie die max. Geschwindigkeit ein (km/h):\t";
			cin >> dNeuVMax;
			
			vectFahrzeugliste.push_back(
				new Fahrrad(sNeuName, dNeuVMax)
				);
		}
		else break;
	}//Einlesen ende

	if(vectFahrzeugliste.size() == 0)
	{
		cout << "Keine Fahrzeuge fuer die Simulation... ENDE" << endl;
		return;
	}

	//Simulation eine Weile laufen lassen
	for(int i=0; i<=24; i++)
	{
		cout << endl << "Schritt " << i << " nach " << dGlobaleZeit << " Stunden";
		if(i == 12) cout << ", AUFGETANKT";
		cout << endl;
		vTabellenKopf();
		//Fahrzeuge abfertigen
		for(unsigned int j=0; j < vectFahrzeugliste.size(); j++)//unsigned muss sein, sonst Konfliktwarnung des Compilers
		{
			vectFahrzeugliste[j]->vAbfertigung();
			if(i == 12) vectFahrzeugliste[j]->dTanken();
			vectFahrzeugliste[j]->vAusgabe();
			cout << endl;
		}
		dGlobaleZeit += TAKT;
	}
}

void vAufgabe_3(void)
{
	//Einige PKW, Fahrzeuge und Fahrraeder anlegen
	Fahrzeug faAuto1("Fahrzeug1", 100.0);
	Fahrzeug faAuto2("Fahrzeug2", 305.0);
	PKW pkwAuto3("PKW1", 110.0, 9.0);
	Fahrrad fahrradAuto4("Fahrrad1", 50);

	vTabellenKopf();
	cout << faAuto1 << endl << faAuto2 << endl << pkwAuto3 << endl << fahrradAuto4 << endl;
	
	for(int i=0; i<=5; i++) //Objekte einige Zeit lang abfertigen
	{
		faAuto1.vAbfertigung();
		faAuto2.vAbfertigung();
		pkwAuto3.vAbfertigung();
		fahrradAuto4.vAbfertigung();
		dGlobaleZeit += TAKT;
	}
	
	vTabellenKopf();
	cout << faAuto1 << endl << faAuto2 << endl << pkwAuto3 << endl << fahrradAuto4 << endl;
	if(faAuto2 < faAuto1) cout << "Auto 1 ist weiter als Auto 2" << endl;
	else cout << "Auto 2 ist weiter als Auto 1" << endl;
	if(fahrradAuto4 < pkwAuto3) cout << "Das Fahrrad ist weniger weit als der PKW" << endl;
	else cout << "Das Fahrrad ist weiter als der PKW" << endl;

	Fahrzeug faCopyConst(faAuto1);
	Fahrzeug faZuweisungsKopie = faAuto1;
	cout << "Konstruktortests:" << endl;
	vTabellenKopf();
	cout << "Copy-Constructor: " << endl << faCopyConst << endl
		<< "Zuweisungskopie:" << endl << faZuweisungsKopie << endl;

	Fahrzeug faIDTest("Test", 20);
	cout << "Test, ob ID noch aktualisiert wird:" << endl << faIDTest << endl;
}

void main()
{
	//vAufgabe_1();
	//vAufgabe_1_deb();
	//vAufgabe_2();
	vAufgabe_3();
}
//(C) MG, WiSe 2011/2012