#include "Weg.h"
#include <list>

#include "Fahrzeug.h"
#include <math.h>

#include <iostream>
#include <iomanip>
using namespace std;

#define EPSILON 0.0166 //ca. 1 Minute wenn die Zeit in Stunden gemessen wird.

//globale Zeit bekanntmachen
extern double dGlobaleZeit;

//########################### Konstruktoren, Destruktor ###############################
Weg::Weg(void) :AktivesVO() {} //Standard-Konstruktor

Weg::Weg(string sIniName, double dIniLaenge, Begrenzung eIniLimit) //erweiterter Konstruktor
	: AktivesVO()
{
	p_sName = sIniName;
	p_dLaenge = dIniLaenge;
	p_eLimit = eIniLimit;
}

Weg::~Weg(void)
{
}

//########################### Wirkfunktionen #############################################
ostream& Weg::ostreamAusgabe(ostream& ostreamrefZiel)
{
	AktivesVO::ostreamAusgabe(ostreamrefZiel);
	ostreamrefZiel << setiosflags(ios::right) << setiosflags(ios::fixed) 
		<< setw(10) << setprecision(2) << p_dLaenge
		<< resetiosflags(ios::fixed) << resetiosflags(ios::right);

	if(p_pFahrzeuge.empty()) 
		return ostreamrefZiel; //leere Liste muss nicht ausgegebene werden
	else
	{
		ostreamrefZiel << " ( ";
		list<Fahrzeug*>::iterator i;
		for(i = p_pFahrzeuge.begin(); i != p_pFahrzeuge.end(); ++i) 
		{
			ostreamrefZiel << (*i)->sGetName() << " "; 
		}

		ostreamrefZiel << ")";
	}
	return ostreamrefZiel;
}

void Weg::vAbfertigung()
{
	if(p_pFahrzeuge.empty()) return; //Ein Weg ohne Fahrzeuge muss nicht abgefertigt werden

	list<Fahrzeug*>::iterator i;
	for(i = p_pFahrzeuge.begin(); i != p_pFahrzeuge.end(); ++i) 
		(*i)->vAbfertigung();
}

void Weg::vAnnahme(Fahrzeug* pAufnehmFahrzeug) //setzt ein fahrendes Fahrzeug an den Anfang dieses Weges
{
	p_pFahrzeuge.push_back(pAufnehmFahrzeug);
	pAufnehmFahrzeug->vNeueStrecke(this); //Fahrzeug mit dem Weg bekannt machen
}

void Weg::vAnnahme(Fahrzeug* pAufnehmFahrzeug, double dIniStartZeit) //setzt ein parkendes Fahrzeug...
{
	p_pFahrzeuge.push_back(pAufnehmFahrzeug);
	pAufnehmFahrzeug->vNeueStrecke(this, dIniStartZeit);
}
//(C) MG, WiSe 2011/2012