#include "FzgFahren.h"
#include "Weg.h"
#include "Fahrzeug.h"
#include "Streckenende.h"


//########################### Konstruktoren, Destruktor ##############################
FzgFahren::FzgFahren(Weg* pIniWeg) 
	:FzgVerhalten(pIniWeg){};
FzgFahren::FzgFahren(void){}
FzgFahren::~FzgFahren(void){}

//########################### Wirkfunktionen #########################################
double FzgFahren::dStrecke(Fahrzeug* pFahrzeug, double dZeitvorgabe) const
{
	double dMaxStrecke = pFahrzeug->dGeschwindigkeit() * dZeitvorgabe;
	
	if(pFahrzeug->dGetAbschnittStrecke() >= p_pAktuellerWeg->dGetLaenge())
		//das Fahrzeug steht schon am Ende des aktuellen Weges
		throw new Streckenende(pFahrzeug, p_pAktuellerWeg);

	if(pFahrzeug->dGetAbschnittStrecke() + dMaxStrecke > p_pAktuellerWeg->dGetLaenge())
		//das Fahrzeug erreicht im nchsten Takt das Ende des aktuellen Weges
		return p_pAktuellerWeg->dGetLaenge() - pFahrzeug->dGetAbschnittStrecke();
	
	return dMaxStrecke;
}
//(C) MG, WiSe 2011/2012