#include "AktivesVO.h"
#include "Fahrzeug.h"
#include "PKW.h"
#include "Fahrrad.h"
#include "Weg.h"
#include "LazyListe.h"

#include "SimuClient.h"
#include <vector>
#include <windows.h>
#include <stdlib.h>

#include <iostream>
#include <string>
#include <iomanip>
using namespace std;

#define TAKT 0.25 //Laenge eines Zeittaktes in Stunden

// globale Deklarationen
int AktivesVO::p_iMaxID = 0;
double dGlobaleZeit = 0.0;

void vTabellenKopf() //gibt den formatierten Kopf einer Fahrzeugtabelle aus
{
	cout << endl << "##########################################"
		<< "#######################################################" << endl
		<< setw(4) << setiosflags(ios::left) << "ID" 
		<<  setw(10) << "Name" 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setw(10) << "Vmax (km/h)"
		<< setw(10) << "V (km/h)"
		<< setw(10) << "ODT (km)" 
		<< setw(10) << "Trip (km)"
		<< setw(10) << "fuel (l)"
		<< setw(15) << "OConsumpt (l)" << endl
		<< resetiosflags(ios::right) << setiosflags(ios::left)
		<< setw(14) << ""
		<< setw(3) << ":"
		<< resetiosflags(ios::left) << setiosflags(ios::right)
		<< setw(10) << "/Laenge (km)" << endl
		<< resetiosflags(ios::right)
		<< "------------------------------------------"
		<< "-------------------------------------------------------" << endl;
}

void vAufgabe_4()
{
	/* zeigt nur noch die Funktionalitt von Aufgabe 5, weil die Abbruchbedingungen durch das Exception
	Handling von Aufgabe 5 berdeckt wurde. */
	Weg wStrasse1("A4", 100, Innerorts);
	Fahrzeug fFahrzeug1("Fzg", 110);
	PKW pkFahrzeug2("PKW", 70, 7);
	Fahrrad frFahrzeug3("Fahrrad", 55);
	PKW pkFahrzeug4("Parker", 70, 7);

	wStrasse1.vAnnahme(&fFahrzeug1);
	wStrasse1.vAnnahme(&pkFahrzeug2);
	wStrasse1.vAnnahme(&frFahrzeug3);
	wStrasse1.vAnnahme(&pkFahrzeug4, 0.5);

	vTabellenKopf();
	cout << wStrasse1 << endl;
	vTabellenKopf();
	for(int i=0; i<=7; i++)
	{
		wStrasse1.vAbfertigung();
		cout << "Schritt " << i << endl << fFahrzeug1 << endl << pkFahrzeug2 << endl 
			<< frFahrzeug3 << endl << pkFahrzeug4 << endl;
		dGlobaleZeit += TAKT;
	}
}

void vAufgabe_5()
{
	Weg wHinweg("Hinweg", 500);
	Weg wRueckweg("Rueckweg", 500);

	PKW Auto1("Opel", 110, 7, 40);
	PKW Auto2("BMW", 250, 15, 100);
	Fahrrad Bike("Rennrad", 65);
	
	wHinweg.vAnnahme(&Auto1);
	wHinweg.vAnnahme(&Bike);
	wRueckweg.vAnnahme(&Auto2);
	cout << "Objekte erstellt und Fahrzeuge auf Wege gesetzt. Starte SimuClient..." << endl;

	bInitialisiereGrafik(800,500);
	cout << "SimuClient laeuft. Zeichne Strasse..." << endl;

	int iZeichenKoordinaten[4] = {700, 250, 100, 250};
	bZeichneStrasse(wHinweg.sGetName(), wRueckweg.sGetName(), 500, 2, iZeichenKoordinaten);
	cout << "Strasse gezeichnet. Starte Simulation..." << endl;
	vTabellenKopf();
	
	for(int i=0; i<=48; i++)
	{
		wHinweg.vAbfertigung();
		wRueckweg.vAbfertigung();
		cout << "Schritt " << i << endl << Auto1 << endl << Auto2 << endl 
			<< Bike << endl;

		vSetzeZeit(dGlobaleZeit);
		Auto1.vZeichnen(&wHinweg); Auto2.vZeichnen(&wRueckweg); Bike.vZeichnen(&wHinweg);

		if(i%4 == 0)
		{
			Auto1.dTanken();
			Auto2.dTanken();
		}
		dGlobaleZeit += TAKT;
		Sleep(500);
	}

	cout << "Simulation beendet. Warte auf Eingabe, dann beende SimuClient." << endl;
	vBeendeGrafik();

}

void vAufgabe_6() //soll abschmieren wegen Iteratorfehler.
{
	Weg wHinweg("Hinweg", 500);

	PKW Auto1("Fahrer", 110, 7, 40);
	PKW Auto2("Parker", 250, 15, 100);
	Fahrrad Bike("Rennrad", 65);
	
	wHinweg.vAnnahme(&Auto1);
	wHinweg.vAnnahme(&Bike);
	wHinweg.vAnnahme(&Auto2, 1);

	vTabellenKopf();
	
	for(int i=0; i<=48; i++)
	{
		wHinweg.vAbfertigung();
		cout << "Schritt " << i << endl << Auto1 << endl << Auto2 << endl 
			<< Bike << endl;

		if(i%4 == 0)
		{
			Auto1.dTanken();
			Auto2.dTanken();
		}
		dGlobaleZeit += TAKT;
	}
}

void vAufgabe_6a()
{
	LazyListe<int> layliZahlenListe;
	LazyListe<int>::iterator it;
	int iZahl = 0;

	cout << "Liste angelegt." << endl;
	
	for(int i = 1; i<= 35; i++)
	{
		iZahl = rand() % 11;
		layliZahlenListe.push_back(iZahl);
	}
	layliZahlenListe.vAktualisieren();

	cout << "Zahlen eingelesen. Liste wird ausgegeben." << endl;

	for(it = layliZahlenListe.begin(); it != layliZahlenListe.end(); ++it)
	{
		cout << (*it) << " ";
	}
	cout << endl << "Alle Zahlen < 5: Loeschung anweisen. Liste ausgeben." << endl;

	for(it = layliZahlenListe.begin(); it != layliZahlenListe.end(); ++it)
	{
		if((*it) < 5) layliZahlenListe.erase(it);
	}

	for(it = layliZahlenListe.begin(); it != layliZahlenListe.end(); ++it)
	{
		cout << (*it) << " ";
	}
	cout << endl << "Jetzt Liste aktualisieren und ausgeben:" << endl;

	layliZahlenListe.vAktualisieren();

	for(it = layliZahlenListe.begin(); it != layliZahlenListe.end(); ++it)
	{
		cout << (*it) << " ";
	}
	cout << endl << "Am Anfang und am Ende je 2 Zahlen anhaengen:" << endl;

	for(int i = 1; i <= 4; i++)
	{
		iZahl = rand() % 11;
		if( i <= 2)	layliZahlenListe.push_back(iZahl);
		else layliZahlenListe.push_front(iZahl);
	}

	layliZahlenListe.vAktualisieren();

	for(it = layliZahlenListe.begin(); it != layliZahlenListe.end(); ++it)
	{
		cout << (*it) << " ";
	}
	cout << endl;
}

void main()
{
	//vAufgabe_1();
	//vAufgabe_1_deb();
	//vAufgabe_2();
	//vAufgabe_3();
	//vAufgabe_4();
	//vAufgabe_5();
	//vAufgabe_6();
	//vAufgabe_6a();

}
//(C) MG, WiSe 2011/2012