#pragma once
#include "AktivesVO.h"

#include <string>
using namespace std;

class FzgVerhalten;
class Weg;

class Fahrzeug
	: public AktivesVO
{
public:
	//Funktionen
	Fahrzeug(void);
	//Fahrzeug(const Fahrzeug& farefUrbild); //selbst definierter Copy-Konstruktor
	Fahrzeug(string sIniName);
	Fahrzeug(string sIniName, double dVMax); //die drei Konstruktoren
	virtual ~Fahrzeug(void);

	virtual double dTanken(double dMenge = 0.0); //virtuelle Tankfunktion
	virtual void vAusgabe(void) const; //Ausgabefunktion, wird nicht mehr gebraucht
	virtual ostream& ostreamAusgabe(ostream& ostreamrefZiel); //Ausgabefunktion fuer den ueberladenen <<-Operator
	virtual void vAbfertigung(void); //Abfertigungsfunktion

	virtual double dGeschwindigkeit(void) const; //Die Geschwindigkeitsfunktion
	virtual void vZeichnen(Weg* pIniWeg); //Zeichenfunktion
	void vNeueStrecke(Weg* pIniWeg); //passt das Verhaltensmuster des Fzg an den neuen Weg an
	void vNeueStrecke(Weg* pIniWeg, double dIniStartZeit); //weist dem Fzg auf dem neuen Weg ein Parken Verhaltensmuster zu

	//bool operator<(const Fahrzeug& farefAnderesFahrzeug); //Vergleichsoperator
	//void operator=(const Fahrzeug& farefUrbild); //neuer Zuweisungsoperator

	//Get-Funktionen
	double dGetAbschnittStrecke(void){return p_dAbschnittStrecke;}

protected:
	//Variablen
	double p_dMaxGeschwindigkeit;	//technische Hoechstgeschwindigkeit des Fahrzeugs
	double p_dGesamtStrecke;		//Tachostand des Fahrzeugs
	double p_dGesamtZeit;			//gesamte Fahrzeit
	double p_dAbschnittStrecke;		//auf diesem Weg zuruekgelegte Strecke
	FzgVerhalten* p_pVerhalten;		//um das Fahrzeugverhalten festlegen zu knnen

private:
	void vInitialisierung(void);
};
//(C) MG, WiSe 2011/2012