#pragma once
#include "aktivesvo.h"
#include "LazyListe.h"

#include <string>
using namespace std;

class Fahrzeug;
enum Begrenzung {Innerorts = 50, Landstrae = 100, Autobahn};

class Weg :
	public AktivesVO
{
public:
	Weg(string sIniName, double dIniLaenge, Begrenzung eIniLimit = Autobahn, bool Ueberholverbot = true); //erweiterter Konstruktor
	virtual ~Weg(void);

	ostream& ostreamAusgabe(ostream& ostreamrefZiel); //gibt ein Label des Weges aus
	void vListeAusgabe(void); //gibt die in der Liste gespeicherten Fahrzeuge auf cout aus
	void vAbfertigung(void);
	void vAnnahme(Fahrzeug* pAufnehmFahrzeug); //Annahme fahrendes Fahrzeug
	void vAnnahme(Fahrzeug* pAufnehmFahrzeug, double dIniStartZeit); //Annahme parkendes Fahrzeug
	void vAbgabe(Fahrzeug* pAbgebeFahrzeug); //Abgabe eines Fahrzeuges

	//Get-Funktionen
	double dGetLaenge(void){return p_dLaenge;}
	double dGetLimit(void){return p_eLimit;}
	bool bGetUeberholverbot(void){return p_bUeberholverbot;}
	double dGetSchranke(void){return p_dSchranke;}
	//Set-Funktionen
	void vSetSchranke(double dNeuerWert){p_dSchranke = dNeuerWert;}
	
private:
	Weg(void); //Standardkonstruktor, unnoetig

	bool p_bUeberholverbot;				//Ueberholverbot
	double p_dLaenge;					//Weglaenge in km
	double p_dSchranke;					//Schranke fuer das Ueberholverbot
	LazyListe<Fahrzeug*> p_pFahrzeuge;	//Liste der auf dem Weg befindlichen Fahrzeuge
	Begrenzung p_eLimit;				//Geschwindigkeitsbegrenzung
};
//(C) MG, WiSe 2011/2012
