#include "AktivesVO.h"
#include "Fahrzeug.h"
#include "PKW.h"
#include "Fahrrad.h"
#include "Weg.h"
#include "LazyListe.h"

#include "SimuClient.h"
#include <vector>
#include <windows.h>
#include <stdlib.h>

#include <iostream>
#include <string>
#include <iomanip>
using namespace std;

#define TAKT 0.25 //Laenge eines Zeittaktes in Stunden

// globale Deklarationen
int AktivesVO::p_iMaxID = 0;
double dGlobaleZeit = 0.0;

void vTabellenKopf() //gibt den formatierten Kopf einer Fahrzeugtabelle aus
{
	cout << endl << "##########################################"
		<< "#######################################################" << endl
		<< setw(4) << setiosflags(ios::left) << "ID" 
		<<  setw(10) << "Name" 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setw(10) << "Vmax (km/h)"
		<< setw(10) << "V (km/h)"
		<< setw(10) << "ODT (km)" 
		<< setw(10) << "Trip (km)"
		<< setw(10) << "fuel (l)"
		<< setw(15) << "OConsumpt (l)" << endl
		<< resetiosflags(ios::right) << setiosflags(ios::left)
		<< setw(14) << ""
		<< setw(3) << ":"
		<< resetiosflags(ios::left) << setiosflags(ios::right)
		<< setw(10) << "/Laenge (km)" << endl
		<< resetiosflags(ios::right)
		<< "------------------------------------------"
		<< "-------------------------------------------------------" << endl;
}

#define MAXZEIT 24.0
void vAufgabe_7()
{
	bool bDoneOnce = false;

	Weg wHinweg("Hinweg", 200, Autobahn);
	Weg wRueckweg("Rueckweg", 200, Autobahn);

	PKW Auto1("Auto", 100, 7, 10);
	PKW Auto2("AutoSp", 100, 15, 100);
	Fahrrad Bike("Rad", 50);
	
	wHinweg.vAnnahme(&Auto1, 1);
	wHinweg.vAnnahme(&Bike, 1.5);
	cout << "Objekte erstellt und Fahrzeuge auf den Weg gesetzt. Starte SimuClient..." << endl;

	bInitialisiereGrafik(800,500);
	cout << "SimuClient laeuft. Zeichne Strasse..." << endl;

	int iZeichenKoordinaten[4] = {700, 250, 100, 250};
	bZeichneStrasse(wHinweg.sGetName(), wRueckweg.sGetName(), 200, 2, iZeichenKoordinaten);
	cout << "Strasse gezeichnet. Starte Simulation..." << endl;

	vTabellenKopf();
	for(int i = 0; i <= MAXZEIT; i++)
	{
		cout << "Zeit: " << dGlobaleZeit << ", Schritt " << i << endl;

		if(fabs(i - MAXZEIT/2) < 0.2 && !(bDoneOnce)) // bei Halbzeit genau ein mal ein Auto annehmen
		{
			cout << "Neues Fahrzeug aufgenommen." << endl;
			wHinweg.vAnnahme(&Auto2);
			bDoneOnce = true;
		}

		wHinweg.vAbfertigung(); // Weg abfertigen
		wHinweg.vListeAusgabe(); //Liste aller Fahrzeuge ausgeben
		

		Auto1.vZeichnen(&wHinweg); Bike.vZeichnen(&wHinweg);
		if(i > MAXZEIT/2) Auto2.vZeichnen(&wHinweg);

		

		dGlobaleZeit += TAKT;
		Sleep(250);
		cout << "-------" << endl;
	}
	vBeendeGrafik();
}
void drawtest()
{
	Weg wHinweg("Hinweg", 150);
	Weg wRueckweg("Rueckweg", 150);

	PKW Auto1("Auto", 50, 7, 40);
	
	wHinweg.vAnnahme(&Auto1);
	cout << "Objekte erstellt und Fahrzeuge auf den Weg gesetzt. Starte SimuClient..." << endl;

	bInitialisiereGrafik(800,500);
	cout << "SimuClient laeuft. Zeichne Strasse..." << endl;

	int iZeichenKoordinaten[4] = {700, 250, 100, 250};
	bZeichneStrasse(wHinweg.sGetName(), wRueckweg.sGetName(), 150, 2, iZeichenKoordinaten);
	cout << "Strasse gezeichnet. Starte Simulation..." << endl;

	Auto1.vZeichnen(&wHinweg);
	Sleep(1000);
	vBeendeGrafik();
}

void main()
{
	//vAufgabe_6();
	//vAufgabe_6a();
	vAufgabe_7();
	//drawtest();

}
//(C) MG, WiSe 2011/2012