#include "Fahrzeug.h"
#include "FzgVerhalten.h"
#include "FzgFahren.h"
#include "FzgParken.h"
#include "Weg.h"
#include <math.h>

#include <iostream>
#include <iomanip>
using namespace std;

#define EPSILON 0.0166 //ca. 1 Minute wenn die Zeit in Stunden gemessen wird.

//globale Zeit bekanntmachen
extern double dGlobaleZeit;

//######################## Konstruktoren, Destruktor ############################
void Fahrzeug::vInitialisierung(void)
{
	p_dMaxGeschwindigkeit = 0.0;
	p_dGesamtStrecke = 0.0;
	p_dGesamtZeit = 0.0;
	p_dAbschnittStrecke = 0.0;
	p_pVerhalten = NULL;
}

Fahrzeug::Fahrzeug(void) //Standard-Konstruktor
	:AktivesVO()
{vInitialisierung();}

Fahrzeug::Fahrzeug(string sIniName) //nur Name
{
	vInitialisierung();
	p_sName = sIniName; //Name aendern
}

Fahrzeug::Fahrzeug(string sIniName, double dVMax) //Name und Hchstgeschwindigkeit
{
	vInitialisierung();
	p_sName = sIniName; //Name aendern
	p_dMaxGeschwindigkeit = dVMax; //Hoechstgeschwindigkeit festlegen
}


Fahrzeug::~Fahrzeug(void){/*Destroyy*/} //Destruktor
//############## Wirkfunktionen ###################################################

void Fahrzeug::vAusgabe(void) const //Ausgabefunktion
{
	cout << setw(4) << setiosflags(ios::left) << p_iID 
		<<  setw(10) << p_sName 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) 
		<< setw(10) << setprecision(2) << p_dMaxGeschwindigkeit 
		<< setw(10) << setprecision(2) << dGeschwindigkeit()
		<< setw(10) << setprecision(2) << setbase(10) << p_dGesamtStrecke
		<< setw(10) << setprecision(2) << setbase(10) << p_dAbschnittStrecke
		<< resetiosflags(ios::fixed) << resetiosflags(ios::right);
}

ostream& Fahrzeug::ostreamAusgabe(ostream& ostreamrefZiel) //Ausgabefkt fuer den <<-Operator
{
	AktivesVO::ostreamAusgabe(ostreamrefZiel);
	ostreamrefZiel << setiosflags(ios::right) << setiosflags(ios::fixed) 
		<< setw(10) << setprecision(2) << p_dMaxGeschwindigkeit 
		<< setw(10) << setprecision(2) << dGeschwindigkeit()
		<< setw(10) << setprecision(2) << setbase(10) << p_dGesamtStrecke 
		<< setw(10) << setprecision(2) << setbase(10) << p_dAbschnittStrecke 
		<< resetiosflags(ios::fixed) << resetiosflags(ios::right);
	return ostreamrefZiel;
}

void Fahrzeug::vAbfertigung(void) //fertigt das Fahrzeug fuer einen Zeitschritt ab
{
	if(fabs(dGlobaleZeit - p_dZeit) > EPSILON)
	{
		/*Kopie der Variablen ist erforderlich, weil sonst die doppelte Aktualisierung bei Faehrradern
		zu einer verdoppelten Berechnung der Geschwindigkeitsabnahme fuehrt.*/
		double dWegstueck = p_pVerhalten->dStrecke(this, fabs(dGlobaleZeit - p_dZeit));
		p_dAbschnittStrecke += dWegstueck;
		p_dGesamtStrecke += dWegstueck;

		p_dZeit = dGlobaleZeit;
	}
	p_dGesamtZeit = dGlobaleZeit;
}

void Fahrzeug::vNeueStrecke(Weg* pIniWeg) //setzt ein "fahrend"-Verhaltensmuster
{
	if(p_pVerhalten != NULL) delete p_pVerhalten; //altes Verhaltensmuster lschen, Speicher freigeben
	p_pVerhalten = new FzgFahren(pIniWeg);
	p_dAbschnittStrecke = 0.0; //Abschnittskm-Zaehler zuruecksetzen
	p_dZeit = dGlobaleZeit; //erlaubt das spaetere Aufnehmen von Fahrzeugen und verhindert das Nachholen von km
}

void Fahrzeug::vNeueStrecke(Weg* pIniWeg, double dIniStartZeit) //setzt ein "parkend"-Verhaltensmuster
{
	if(p_pVerhalten != NULL) delete p_pVerhalten; //altes Verhaltensmuster lschen, Speicher freigeben
	p_pVerhalten = new FzgParken(pIniWeg, dIniStartZeit);
	p_dAbschnittStrecke = 0.0; //Abschnittskm-Zaehler zuruecksetzen
	p_dZeit = dGlobaleZeit;
}

/*muss irgendwie beschrieben sein, aufgerufen wird letztenendes jedoch nur die Funktion,
welche in den abgeleiteten Klassen PKW und Fahrrad implementiert ist.*/
double Fahrzeug::dGeschwindigkeit(void) const {return p_dMaxGeschwindigkeit;}
double Fahrzeug::dTanken(double dMenge){return 0.0;}
void Fahrzeug::vZeichnen(Weg* pIniWeg) {}
//(C) MG, WiSe 2011/2012