#include "Kreuzung.h"
#include "Weg.h"
#include "Fahrzeug.h"
#include "PKW.h"
#include "Fahrrad.h"

#include <iostream>
#include <iomanip>
using namespace std;

//########################## Konstruktoren, Destruktor #########################
Kreuzung::Kreuzung(string sIniName, double dTankVolumen) : AktivesVO()
{
	p_sName = sIniName;
	p_dTankstelle = dTankVolumen;
}
Kreuzung::Kreuzung(void){}
Kreuzung::~Kreuzung(void){}
//############################ Wirkfunktionen ####################################
ostream& Kreuzung::ostreamAusgabe(ostream& ostreamrefZiel)
{
	ostreamrefZiel << "------------" << endl;
	AktivesVO::ostreamAusgabe(ostreamrefZiel);
	ostreamrefZiel << "hat noch " 
		<< setiosflags(ios::fixed) << setprecision(2) << setbase(10)
		<<p_dTankstelle << " Liter Sprit und kennt folgende Wege:"
		<< resetiosflags(ios::fixed);

	if(p_pAusgehendeWege.empty()) 
		return ostreamrefZiel; //leere Liste muss nicht ausgegebene werden
	else
	{
		list<Weg*>::iterator i;
		for(i = p_pAusgehendeWege.begin(); i != p_pAusgehendeWege.end(); ++i) 
		{
			ostreamrefZiel << endl; 
			(*i)->ostreamAusgabe(ostreamrefZiel);
		}
	}
	return ostreamrefZiel;
}

void Kreuzung::vTanken(Fahrzeug* pFahrzeug)
{
	if(p_dTankstelle > 0)
		p_dTankstelle -= pFahrzeug->dTanken();

	if(p_dTankstelle < 0) p_dTankstelle = 0;
}

void Kreuzung::vVerbinde(string sHinwegName, string sRueckwegName, double dWegLaenge, Kreuzung* pZiel, Begrenzung eLimit, bool Ueberholverbot)
{
	//die beiden neuen Wege anlegen
	Weg* pNeuerWegRaus = new Weg(sHinwegName, dWegLaenge, eLimit, Ueberholverbot);
	Weg* pNeuerWegRein = new Weg(sRueckwegName, dWegLaenge, eLimit, Ueberholverbot);

	//Wege untereinander bekanntmachen
	pNeuerWegRaus->vSetRueckweg(pNeuerWegRein);
	pNeuerWegRein->vSetRueckweg(pNeuerWegRaus);

	//Den Wegen ihre Endkreuzungen bekanntmachen
	pNeuerWegRaus->vSetEndKreuzung(pZiel);
	pNeuerWegRein->vSetEndKreuzung(this);

	//den jeweiligen Ausgangskreuzungen ihre Wege bekanntmachen
	vMacheWegBekannt(pNeuerWegRaus);
	pZiel->vMacheWegBekannt(pNeuerWegRein);
}

void Kreuzung::vAnnahme(Fahrzeug* pNeuesFahrzeug, double dStartZeit)
{
	if(p_pAusgehendeWege.empty()) //Fehler abfangen
	{
		cout << "FEHLER: Der Kreuzung ist kein Weg bekannt." << endl;
		return;
	}
	//Fahrzeug anhaengen
	vTanken(pNeuesFahrzeug);
	(*(p_pAusgehendeWege.begin()))->vAnnahme(pNeuesFahrzeug, dStartZeit);
}

void Kreuzung::vAbfertigung(void)
{
	if(p_pAusgehendeWege.empty()) return; //Keine Wege vorhanden

	list<Weg*>::iterator i;
	for(i = p_pAusgehendeWege.begin(); i != p_pAusgehendeWege.end(); ++i)
	{
		(*i)->vAbfertigung();
	}
}

Weg* Kreuzung::ptZufaelligerWeg(Weg* pHinweg)
{
	Weg* pRueckweg = pHinweg->pGetRueckweg();

	if(p_pAusgehendeWege.empty()) //es gibt keine ausgehenden Wege
	{
		cout << "FEHLER: Kreuzung " << p_sName << " kennt keine ausgehenden Wege.";
		return pRueckweg;
	}

	if(p_pAusgehendeWege.size() == 1) // es gibt nur einen einzigen ausgehenden Weg
		return *(p_pAusgehendeWege.begin());
	else //es gibt mehr als einen ausgehenden Weg
	{
		for(int iSecCount = 0; iSecCount <= 100; iSecCount++) //unechte Endlosschleife
		{
			int iZufallsZahl = rand() % (int)p_pAusgehendeWege.size();
			list<Weg*>::iterator it;
			it = p_pAusgehendeWege.begin();
			for(int i = 0; i< iZufallsZahl; ++i) ++it; //an eine zufaellige Stelle in der Wegeliste gehen

			if((*it) != pRueckweg) return *it; //wenn das der Rueckweg ist, neuer Versuch, sonst Ende.
		}
		return pRueckweg; //irgendwas ist schiefgegangen. Damit es weitergeht, den einzigen sicher bekannten Zeiger zurueckgeben.
	}
}

void Kreuzung::vMacheWegBekannt(Weg* pNeuerWeg) 
{ p_pAusgehendeWege.push_back(pNeuerWeg); }
//by Martin Gritzan, im Rahmen des IF2-Praktikums WiSe 2011/2012