#include "AktivesVO.h"
#include "Fahrzeug.h"
#include "PKW.h"
#include "Fahrrad.h"
#include "Weg.h"
#include "LazyListe.h"
#include "Kreuzung.h"

#include "SimuClient.h"
#include <vector>
#include <windows.h>
#include <stdlib.h>

#include <iostream>
#include <string>
#include <iomanip>
using namespace std;

#define TAKT 0.25 //Laenge eines Zeittaktes in Stunden

// globale Deklarationen
int AktivesVO::p_iMaxID = 0;
double dGlobaleZeit = 0.0;
bool bGrafikAktiv = false;

void vTabellenKopf() //gibt den formatierten Kopf einer Fahrzeugtabelle aus
{
	cout << endl << "##########################################"
		<< "#######################################################" << endl
		<< "Zeit: " << dGlobaleZeit << endl
		<< setw(4) << setiosflags(ios::left) << "ID" 
		<<  setw(10) << "Name" 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setw(10) << "Vmax (km/h)"
		<< setw(10) << "V (km/h)"
		<< setw(10) << "GesamtKM" 
		<< setw(10) << "AbschnKM"
		<< setw(10) << "TankInh"
		<< setw(15) << "Verbraucht" << endl
		<< resetiosflags(ios::right) << setiosflags(ios::left)
		<< setw(14) << ""
		<< setw(3) << ":"
		<< resetiosflags(ios::left) << setiosflags(ios::right)
		<< setw(10) << "Weglaenge" << endl
		<< resetiosflags(ios::right)
		<< "------------------------------------------"
		<< "-------------------------------------------------------" << endl;
}

#define MAXZEIT 24.0
void vAufgabe_7()
{
	bool bDoneOnce = false;

	Weg wHinweg("Hinweg", 200, Autobahn);
	Weg wRueckweg("Rueckweg", 200, Autobahn);

	PKW Auto1("Auto", 100, 7, 10);
	PKW Auto2("AutoSp", 100, 15, 100);
	Fahrrad Bike("Rad", 50);
	
	wHinweg.vAnnahme(&Auto1, 1);
	wHinweg.vAnnahme(&Bike, 1.5);
	cout << "Objekte erstellt und Fahrzeuge auf den Weg gesetzt. Starte SimuClient..." << endl;

	bInitialisiereGrafik(800,500);
	cout << "SimuClient laeuft. Zeichne Strasse..." << endl;

	int iZeichenKoordinaten[4] = {700, 250, 100, 250};
	bZeichneStrasse(wHinweg.sGetName(), wRueckweg.sGetName(), 200, 2, iZeichenKoordinaten);
	cout << "Strasse gezeichnet. Starte Simulation..." << endl;

	vTabellenKopf();
	for(int i = 0; i <= MAXZEIT; i++)
	{
		cout << "Zeit: " << dGlobaleZeit << ", Schritt " << i << endl;

		if(fabs(i - MAXZEIT/2) < 0.2 && !(bDoneOnce)) // bei Halbzeit genau ein mal ein Auto annehmen
		{
			cout << "Neues Fahrzeug aufgenommen." << endl;
			wHinweg.vAnnahme(&Auto2);
			bDoneOnce = true;
		}

		wHinweg.vAbfertigung(); // Weg abfertigen
		wHinweg.vListeAusgabe(); //Liste aller Fahrzeuge ausgeben
		

		Auto1.vZeichnen(&wHinweg); Bike.vZeichnen(&wHinweg);
		if(i > MAXZEIT/2) Auto2.vZeichnen(&wHinweg);

		

		dGlobaleZeit += TAKT;
		Sleep(250);
		cout << "-------" << endl;
	}
	vBeendeGrafik();
}

void vAufgabe_8()
{
	cout << "############# AUFGABE 8 ############" << endl;

	cout << "Kreuzungen erzeugen...";
	Kreuzung Knoppunt1("Kr1");
	Kreuzung Knoppunt2("Kr2", 1000);
	Kreuzung Knoppunt3("Kr3");
	Kreuzung Knoppunt4("Kr4");

	cout << "DONE." << endl << "Wege erzeugen...";
	Knoppunt1.vVerbinde("W12", "W21",	40,		&Knoppunt2, Innerorts, true);	//Strasse 1
	Knoppunt2.vVerbinde("W23a", "W32a", 115,	&Knoppunt3, Autobahn, false);	//Strasse 2
	Knoppunt2.vVerbinde("W23b", "W32b", 40,		&Knoppunt3, Innerorts, true);	//Strasse 3
	Knoppunt2.vVerbinde("W24", "W42",	55,		&Knoppunt4, Innerorts, true);	//Strasse 4
	Knoppunt3.vVerbinde("W34", "W43",	85,		&Knoppunt4, Autobahn, false);	//Strasse 5
	Knoppunt4.vVerbinde("W44a", "W44b", 130,	&Knoppunt4, Landstrasse, false);//Strasse 6

	//Koordinatenfelder anlegen
	int Strasse1[4] = {680, 40, 680, 300};
	int Strasse2[12] = {680, 300, 850, 300, 970, 390, 970, 500, 850, 570, 680, 570};
	int Strasse3[4] = {680, 300, 680, 570};
	int Strasse4[4] = {680, 300, 320, 300};
	int Strasse5[10] = {680, 570, 500, 570, 350, 510, 320, 420, 320, 300};
	int Strasse6[14] = {320, 300, 320, 150, 200, 60, 80, 90, 70, 250, 170, 300, 320, 300};

	cout << "DONE." << endl << "Graphische Ausgabe initialisieren...";
	bInitialisiereGrafik(1200,800);
	bGrafikAktiv = true;
	cout << "DONE." << endl << "Kreuzungen zeichnen...";
	bZeichneKreuzung(680, 40); //Kr1
	bZeichneKreuzung(680, 300); //Kr2
	bZeichneKreuzung(680, 570); //Kr3
	bZeichneKreuzung(320, 300); //Kr4

	cout << "DONE." << endl << "Strassen zeichnen...";
	bZeichneStrasse("W12", "W21", 40, 2, Strasse1);
	bZeichneStrasse("W23a", "W32a", 115, 6, Strasse2);
	bZeichneStrasse("W23b", "W32b", 40, 2, Strasse3);
	bZeichneStrasse("W24", "W42", 55, 2, Strasse4);
	bZeichneStrasse("W34", "W43", 85, 5, Strasse5);
	bZeichneStrasse("W44a", "W44b", 130, 7, Strasse6);

	cout << "DONE." << endl << "Fahrzeuge erstellen und auf die Wege setzen...";
	PKW Auto1("Auto1", 70, 6);
	PKW Auto2("Auto2", 100, 6);
	Fahrrad Bike1("Bike1", 50);
	
	Knoppunt1.vAnnahme(&Auto1, 1);
	Knoppunt1.vAnnahme(&Bike1, 0.5);
	Knoppunt4.vAnnahme(&Auto2, 0.5);

	cout <<"DONE." << endl << "Simuliere einige Zeitschritte:" << endl;

	for(int i = 0; i<=24; i++)
	{

		vTabellenKopf();
		cout << "{" << endl;
		Knoppunt1.vAbfertigung();
		Knoppunt2.vAbfertigung();
		Knoppunt3.vAbfertigung();
		Knoppunt4.vAbfertigung();
		cout << "}" << endl;

		/*Bemerkung: 
		Theoretisch muesste nach jeder vollst. Abfertigung aller Kreuzungen jeder Weg auf der Karte
		noch mal aktualisiert werden. Sonst kommt es vor, dass Fahrzeuge, die auf einem in der Queue weit hinten
		liegenden Weg das Streckenende erreicht haben und auf einen schon zuvor zum letzten Mal abgefertigten Weg
		landen, nicht mehr in der Ausgabetabelle erscheinen. Das hat jedoch keinen Einfluss auf die Abfertigung
		der Fahrzeuge.*/
		
		cout << Auto1 << endl << Auto2 << endl << Bike1 << endl;
		cout << Knoppunt1 << endl << Knoppunt2 << endl << Knoppunt3 << endl << Knoppunt4 << endl;

		vSetzeZeit(dGlobaleZeit);
		dGlobaleZeit += TAKT;

		Sleep(500);
	}
	vBeendeGrafik();	
}

void vAufgabe_9()
{
	cout << "############# AUFGABE 9 ############" << endl;
}
void main()
{
	//vAufgabe_6();
	//vAufgabe_6a();
	//vAufgabe_7();
	vAufgabe_8();
	//vAufgabe_9();

}
//(C) MG, WiSe 2011/2012