#include "AktivesVO.h"

#include "Fahrzeug.h"
#include <math.h>

#include <iostream>
#include <iomanip>
using namespace std;

#define EPSILON 0.0166 //ca. 1 Minute wenn die Zeit in Stunden gemessen wird.

//globale Zeit bekanntmachen
extern double dGlobaleZeit;

//statische Variablen initialisieren
int AktivesVO::p_iMaxID = 0;
map<string, AktivesVO*> AktivesVO::p_mWeltkarte;

//######################## Konstruktoren, Destruktor ##############################################
AktivesVO::AktivesVO(void)
{
	p_sName = "";
	p_dZeit = dGlobaleZeit;
	p_iMaxID++;
	p_iID = p_iMaxID;
	bIstFzg = false;
	bIstKreuzung = false;
}


AktivesVO::~AktivesVO(void){}
//######################## Wirkfunktionen #########################################################
ostream& AktivesVO::ostreamAusgabe(ostream& ostreamrefZiel) //Ausgabefkt fuer den <<-Operator
{
	ostreamrefZiel << setw(4) << setiosflags(ios::left) << p_iID 
		<<  setw(10) << p_sName 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left);
	return ostreamrefZiel;
}
istream& AktivesVO::istreamEingabe(istream& istreamrefZiel)
{
	if(p_sName == "")
	{
		istreamrefZiel >> p_sName;
	}
	else throw new string("Dieses Objekt hat bereits den Namen " + p_sName);

	vInWeltkarteSchreiben(p_sName, this);
	return istreamrefZiel;
}

AktivesVO* AktivesVO::ptObjekt(string sSuchName)
{
	map<string, AktivesVO*>::iterator itSucher = p_mWeltkarte.find(sSuchName);
	if(itSucher == p_mWeltkarte.end()) throw new string("Objekt " + sSuchName + " nicht gefunden.");
	return itSucher->second;
}

void AktivesVO::vInWeltkarteSchreiben(string sIniName, AktivesVO* pObjekt)
{
	if(p_mWeltkarte.find(sIniName) != p_mWeltkarte.end())
		throw new string("Ein Objekt mit Namen " + sIniName + " exisitiert schon.");
	p_mWeltkarte[sIniName] = pObjekt;
}

//ueberladener Ausgabeoperator, ausserhalb der Klasse AktivesVO definiert.
ostream& operator<<(ostream& ostreamrefZiel, AktivesVO& VOrefObjekt)
{
	return VOrefObjekt.ostreamAusgabe(ostreamrefZiel);
}
//ueberladener Eingabeoperator
istream& operator>>(istream& istreamrefZiel, AktivesVO& VOrefObjekt)
{
	return VOrefObjekt.istreamEingabe(istreamrefZiel);
}

void AktivesVO::vMapAusgeben(bool bNurFzg)
{
	map<string, AktivesVO*>::iterator it;

	for(it = p_mWeltkarte.begin(); it != p_mWeltkarte.end(); it++)
	{
		if(bNurFzg)
		{
			if(it->second->bIstFzg)
				cout << *(it->second) << endl;
		}
		else cout << *(it->second) << endl;
	}
}
//(C) MG, WiSe 2011/2012