#pragma once

#include <map>
#include <string>
using namespace std;

class AktivesVO
{
public:
	AktivesVO(void);
	virtual ~AktivesVO(void);

	virtual ostream& ostreamAusgabe(ostream& ostreamrefZiel); //Ausgabefunktion
	virtual istream& istreamEingabe(istream& istreamrefZiel); //Eingabefunktion, schreibt das Objekt gleichzeitig in die Weltkarte
	virtual void vAbfertigung(void) = 0; //rein virtuelle Abfertigungsmethode

	string sGetName(void) const {return p_sName;}

	static AktivesVO* ptObjekt(string sSuchName); //sucht ein Objekt dieses Namens in p_mWeltkarte
	static void vInWeltkarteSchreiben(string sIniName, AktivesVO* pObjekt); //schreibt einen neuen Eintrag in die Weltkarte

	static void vMapAusgeben(bool bNurFzg = false); //gibt die Weltkarte aus
	
	bool bIstFzg; //true, wenn es sich bei dieser Instanz um ein Fahrzeug handelt.
	bool bIstKreuzung; //true, wenn es sich um eine Kreuzung handelt.
protected:
	//Variablen
	string p_sName;					//Name des VOs
	int p_iID;						//eideutige ID
	double p_dZeit;					//Zeit, zu der das VO zuletzt abgefertigt wurde
	//statische Variablen
	static int p_iMaxID;
	static map<string, AktivesVO*> p_mWeltkarte;	//eine STL-Map, die alle Objekte ueber ihre Namen abgreifen kann
	//Funktionen
	

private:
	void vInitialisierung(void);
};

ostream& operator<<(ostream& ostreamrefZiel, AktivesVO& VOrefObjekt);
istream& operator>>(istream& istreamrefZiel, AktivesVO& VOrefObjekt);
//(C) MG, WiSe 2011/2012