#pragma once
#include "aktivesvo.h"
#include "LazyListe.h"

#include <string>
using namespace std;

extern bool bGrafikAktiv;
class Fahrzeug;
class Kreuzung;
enum Begrenzung {Innerorts = 50, Landstrasse = 100, Autobahn = 9999};

class Weg :
	public AktivesVO
{
public:
	Weg(void);
	Weg(string sIniName, double dIniLaenge, Begrenzung eIniLimit = Autobahn, bool Ueberholverbot = true); //erweiterter Konstruktor
	virtual ~Weg(void);

	ostream& ostreamAusgabe(ostream& ostreamrefZiel); //gibt ein Label des Weges aus
	istream& istreamEingabe(istream& istreamrefZiel);
	void vListeAusgabe(void); //gibt die in der Liste gespeicherten Fahrzeuge auf cout aus
	void vAbfertigung(void);
	void vAnnahme(Fahrzeug* pAufnehmFahrzeug); //Annahme fahrendes Fahrzeug
	void vAnnahme(Fahrzeug* pAufnehmFahrzeug, double dIniStartZeit); //Annahme parkendes Fahrzeug
	void vAbgabe(Fahrzeug* pAbgebeFahrzeug); //Abgabe eines Fahrzeuges

	//Get-Funktionen
	double dGetLaenge(void){return p_dLaenge;}
	double dGetLimit(void){return p_eLimit;}
	bool bGetUeberholverbot(void){return p_bUeberholverbot;}
	double dGetSchranke(void){return p_dSchranke;}
	Kreuzung* pGetEndKreuzung(void){return p_pEndKreuzung;}
	Weg* pGetRueckweg(void){return p_pRueckweg;}
	//Set-Funktionen
	void vSetSchranke(double dNeuerWert){p_dSchranke = dNeuerWert;}
	void vSetRueckweg(Weg* pNeuerWert){p_pRueckweg = pNeuerWert;}
	void vSetEndKreuzung(Kreuzung* pNeuerWert){p_pEndKreuzung = pNeuerWert;}

	void vAktualisiereLazyListe(void){p_pFahrzeuge.vAktualisieren();}
	
private:
	bool p_bUeberholverbot;				//Ueberholverbot
	double p_dLaenge;					//Weglaenge in km
	double p_dSchranke;					//Schranke fuer das Ueberholverbot
	LazyListe<Fahrzeug*> p_pFahrzeuge;	//Liste der auf dem Weg befindlichen Fahrzeuge
	Begrenzung p_eLimit;				//Geschwindigkeitsbegrenzung
	Weg* p_pRueckweg;					//der zu diesem Weg entgegengesetzte Weg
	Kreuzung* p_pEndKreuzung;			//die Kreuzung, zu der dieser Weg fuehrt
};
//(C) MG, WiSe 2011/2012