#include "Welt.h"
#include "Kreuzung.h"
#include "Weg.h"
#include "Fahrzeug.h"
#include "Fahrrad.h"
#include "PKW.h"
#include "SimuClient.h"

#include <iostream>
using namespace std;

//#################### Konstruktor, Destruktor ##################################
Welt::Welt(void){}
Welt::~Welt(void){}
//#################### Wirkfunktionen ###########################################
void Welt::vEinlesen(istream& Eingabestrom)
{
	string schluessel = "";

	while(!Eingabestrom.eof())
	{
		Eingabestrom >> schluessel;

		//Das Einlesen aus dem Eingabestrom schreibt die Objekte gleichzeitig in die Weltkarte
		if(schluessel == "KREUZUNG")
		{
			try
			{
				Kreuzung* pNeu = new Kreuzung;
				Eingabestrom >> *pNeu;
				cout << "Kreuzung " << pNeu->sGetName() << " erstellt." << endl;
			
				p_pKreuzungen.push_back(pNeu); //schreibt die Kreuzung in die Kreuzungsliste fuer die Abfertigung
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen der neuen Kreuzung: "+ *sFehlermeldung);
			}
		}
		else if(schluessel == "STRASSE")
		{
			try
			{
				string sNameQuelle, sNameZiel, sNameHinweg, sNameRueckweg;
				double dLaenge = 0;
				int eLimit = Autobahn; //darf nur Werte annehmen, die in enum Begrenzung erlaubt sind
				bool bUeberholverbot = true;

				Eingabestrom >> sNameQuelle >> sNameZiel >> sNameHinweg >> sNameRueckweg;
				Eingabestrom >> dLaenge >> eLimit >> bUeberholverbot;
		
				Kreuzung* pQuelle = (Kreuzung*)AktivesVO::ptObjekt(sNameQuelle);//testen schon, ob das Objekt existiert
				Kreuzung* pZiel = (Kreuzung*)AktivesVO::ptObjekt(sNameZiel);

				if(!pQuelle->bIstKreuzung) throw new string(sNameQuelle + " existiert zwar, ist aber keine Kreuzung.");
				if(!pZiel->bIstKreuzung) throw new string(sNameZiel + " existiert zwar, ist aber keine Kreuzung.");

				pQuelle->vVerbinde(sNameHinweg, sNameRueckweg, dLaenge, pZiel, (Begrenzung)eLimit, bUeberholverbot);

				cout << "Strasse<" << sNameHinweg << "," << sNameRueckweg << "> von " << sNameQuelle << " nach " << sNameZiel
					<< " erstellt." << endl;
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen der neuen Strasse: "+ *sFehlermeldung);
			}
		}
		else if(schluessel == "PKW")
		{
			try
			{
				PKW* pNeu = new PKW;
				string sStartKreuzung;
				double dStartZeit = 0;

				Eingabestrom >> *pNeu;
				Eingabestrom >> sStartKreuzung >> dStartZeit;

				Kreuzung* pStart = (Kreuzung*)AktivesVO::ptObjekt(sStartKreuzung);
				pStart->vAnnahme(pNeu, dStartZeit);			

				cout << "PKW " << pNeu->sGetName() << " erzeugt und von Kreuzung " << sStartKreuzung << " angenommen." << endl;
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen eines neuen PKW: "+ *sFehlermeldung);
			}
		}
		else if(schluessel == "FAHRRAD")
		{
			try
			{
				Fahrrad* pNeu = new Fahrrad;
				string sStartKreuzung;
				double dStartZeit = 0;

				Eingabestrom >> *pNeu;
				Eingabestrom >> sStartKreuzung >> dStartZeit;
		
				Kreuzung* pStart = (Kreuzung*)AktivesVO::ptObjekt(sStartKreuzung);
				pStart->vAnnahme(pNeu, dStartZeit);

				cout << "Fahrrad " << pNeu->sGetName() << " erzeugt und von Kreuzung " << sStartKreuzung << " angenommen." << endl;
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen des neuen Fahrrades: "+ *sFehlermeldung);
			}
		}
		else throw new string("Eingabefehler: unbekanntes Schluesselwort '" + schluessel + "'");
	}
	
	
}
void Welt::vEinlesenMitGrafik(istream& Eingabestrom)
{
	string schluessel = "";

	while(!Eingabestrom.eof())
	{
		Eingabestrom >> schluessel;

		//Das Einlesen aus dem Eingabestrom schreibt die Objekte gleichzeitig in die Weltkarte
		if(schluessel == "KREUZUNG")
		{
			try
			{
				Kreuzung* pNeu = new Kreuzung;
				int iKoordX = 0, iKoordY = 0;
				Eingabestrom >> *pNeu;
				Eingabestrom >> iKoordX >> iKoordY;
				bZeichneKreuzung(iKoordX, iKoordY);
				cout << "Kreuzung " << pNeu->sGetName() << " bei Koordinaten " << iKoordX << ","
					<< iKoordY << " erstellt." << endl;
			
				p_pKreuzungen.push_back(pNeu); //schreibt die Kreuzung in die Kreuzungsliste fuer die Abfertigung
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen der neuen Kreuzung: "+ *sFehlermeldung);
			}
		}
		else if(schluessel == "STRASSE")
		{
			try
			{
				string sNameQuelle, sNameZiel, sNameHinweg, sNameRueckweg;
				double dLaenge = 0;
				int eLimit = Autobahn; //darf nur Werte annehmen, die in enum Begrenzung erlaubt sind
				bool bUeberholverbot = true;
				int iAnzahlKoordinatenpaare = 2;
				
				//Dynamisches Array fuer die Koordinaten anlegen:
				//Fuer Informationen siehe http://www.willemer.de/informatik/cpp/dynamic.htm
				int* iKoordinaten = NULL;

				Eingabestrom >> sNameQuelle >> sNameZiel >> sNameHinweg >> sNameRueckweg;
				Eingabestrom >> dLaenge >> eLimit >> bUeberholverbot;
				Eingabestrom >> iAnzahlKoordinatenpaare;
				
				//Dynamisches Array mit Werten fuellen
				iKoordinaten = new int[iAnzahlKoordinatenpaare*2];
				for(int i = 0; i < iAnzahlKoordinatenpaare*2; i++) Eingabestrom >> iKoordinaten[i];
		
				Kreuzung* pQuelle = (Kreuzung*)AktivesVO::ptObjekt(sNameQuelle);//testen schon, ob das Objekt existiert
				Kreuzung* pZiel = (Kreuzung*)AktivesVO::ptObjekt(sNameZiel);

				if(!pQuelle->bIstKreuzung) throw new string(sNameQuelle + " existiert zwar, ist aber keine Kreuzung.");
				if(!pZiel->bIstKreuzung) throw new string(sNameZiel + " existiert zwar, ist aber keine Kreuzung.");

				pQuelle->vVerbinde(sNameHinweg, sNameRueckweg, dLaenge, pZiel, (Begrenzung)eLimit, bUeberholverbot);
				bZeichneStrasse(sNameHinweg, sNameRueckweg, (int)dLaenge, iAnzahlKoordinatenpaare, iKoordinaten);

				//Dynamisches Array wieder freigeben
				delete[] iKoordinaten;
				iKoordinaten = NULL;

				cout << "Strasse<" << sNameHinweg << "," << sNameRueckweg << "> von " << sNameQuelle << " nach " << sNameZiel
					<< " erstellt." << endl;
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen der neuen Strasse: "+ *sFehlermeldung);
			}
		}
		else if(schluessel == "PKW")
		{
			try
			{
				PKW* pNeu = new PKW;
				string sStartKreuzung;
				double dStartZeit = 0;

				Eingabestrom >> *pNeu;
				Eingabestrom >> sStartKreuzung >> dStartZeit;

				Kreuzung* pStart = (Kreuzung*)AktivesVO::ptObjekt(sStartKreuzung);
				pStart->vAnnahme(pNeu, dStartZeit);			

				cout << "PKW " << pNeu->sGetName() << " erzeugt und von Kreuzung " << sStartKreuzung << " angenommen." << endl;
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen eines neuen PKW: "+ *sFehlermeldung);
			}
		}
		else if(schluessel == "FAHRRAD")
		{
			try
			{
				Fahrrad* pNeu = new Fahrrad;
				string sStartKreuzung;
				double dStartZeit = 0;

				Eingabestrom >> *pNeu;
				Eingabestrom >> sStartKreuzung >> dStartZeit;
		
				Kreuzung* pStart = (Kreuzung*)AktivesVO::ptObjekt(sStartKreuzung);
				pStart->vAnnahme(pNeu, dStartZeit);

				cout << "Fahrrad " << pNeu->sGetName() << " erzeugt und von Kreuzung " << sStartKreuzung << " angenommen." << endl;
			}
			catch(string* sFehlermeldung)
			{
				throw new string("Fehler beim erstellen des neuen Fahrrades: "+ *sFehlermeldung);
			}
		}
		else throw new string("Eingabefehler: unbekanntes Schluesselwort '" + schluessel + "'");
	}
	
	
}
void Welt::vSimulation(bool bTextAusgabe)
{
	list<Kreuzung*>::iterator it;

	//alle Kreuzungen abfertigen
	for(it = p_pKreuzungen.begin(); it != p_pKreuzungen.end(); ++it)
		(*it)->vAbfertigung();

	//alle Kreuzungen aktualisieren und ausgeben
	for(it = p_pKreuzungen.begin(); it != p_pKreuzungen.end(); ++it)
	{
		(*it)->vAktualisiereAlleWege();
		if(bTextAusgabe) cout << **it << endl;
	}
}
//(C) MG, WiSe 2011/2012